Bug 241649 - [smolt] smolt-firstboot denaturates its own statistics about default runlevel
[smolt] smolt-firstboot denaturates its own statistics about default runlevel
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: smolt (Show other bugs)
11
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mike McGrath
Fedora Extras Quality Assurance
http://smolt.fedoraproject.org/stats
bzcl34nup
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-05-29 07:33 EDT by Răzvan Sandu
Modified: 2013-01-09 23:19 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-28 06:24:57 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Răzvan Sandu 2007-05-29 07:33:59 EDT
Description of problem:

Hello,

This bug refers to smolt and smolt-fistboot packages (which, btw, are presently
not included in bugzilla's list, under Component section). 

Since smolt runs automatically at first boot after a F7 fresh install, during
the firstboot configuration process, it denaturates it own statistics about
default runlevel: the vast majority of boxes appears to run in X mode, which is
not always true.

The statistics doesn't count the machines that are manually converted to default
runlevel 3 *after* installation, by manually modifying /etc/inittab.

Possible solution: for a more accurate statistics about default runlevel, smolt
should not transmit information about default runlevel to the smolt server when
it is run during firstboot.

Possibly denaturate result do appear at http://smolt.fedoraproject.org/stats,
under Runlevel section.

Regards,
Răzvan


Version-Release number of selected component (if applicable):
Fedora 6.93 as of May 29, 2007.

How reproducible:
Always.

Steps to Reproduce:
1. Install F 6.93 (fresh install).
2. Reboot after installation.
3. During firstboot, users are offered the possibility to send their hardware
profile to the smolt server (which they usually do). This includes information
about default runlevel.
4. If the installation was done in graphic mode (default), first boot will also
be done in graphic mode (runlevel 5).
5. If user manually modifies default runlevel after installation, the smolt
server is provide with statistically incorrect data, unless smolt is re-run
periodically.

  
Actual results:
Statistics at http://smolt.fedoraproject.org/stats, Runlevel section, are
possibly denaturated.

Expected results:
Statistics should reflect a more accurate situation about the default runlevel
of the machines (usually 3 or 5).


Additional info:
Comment 1 Mike McGrath 2007-06-02 03:27:08 EDT
Interesting....

Hmm, actually the default runlevel is pulled directly out of whatever is set in
/etc/inittab (not what runlevel its currently at).  However, those installing in
runlevel 3 will never see smolt get run and will have to set it manually.

One possible saving grace is that those who enable smolt also have enabled a
monthly check in, so on updates, they will get updated.

This, however, still leans heavy to the runlevel 5 side as those installing via
kickstart or runlevel3 (or just not installing firstboot) will never be
presented with the opportunity to enable smolt.  The text version of firstboot
does not include a firstboot module so I can add that and it will help.
Comment 2 Răzvan Sandu 2007-06-03 21:23:39 EDT
Hello,

Please don't forget that the /etc/inittab indicates runlevel 5 after every
canonical install of F7, at first boot, even the administrator manually changes
to 3 a few seconds afterwards, during the initial configuration...


Regards,
Răzvan
Comment 3 Răzvan Sandu 2007-06-10 12:43:06 EDT
Presently (June 10, 2007), the smolt statistics shows that 96.2% of the
registered systems (35279 total) are in default runlevel 5, compared to 3,7% in
runlevel 3.

IMHO, this seems totally unnatural, at least for me. Every network administrator
I know (that mostly use Fedora for servers, not for desktops) boot in default
runlevel 3, both for conserving system resources and for obtaining flexibility.

I will wait for a month after Fedora 7's official release date, to see if
figures begin to change slightly... ;-)


Răzvan
Comment 4 Mike McGrath 2007-06-10 15:02:43 EDT
The problem is that most people running in runlevel 3 are experienced Linux 
admins and as such many of them probably use kickstart scripts or maybe even 
yum to do the update.

In both of those examples smolt does not get installed or run.  All we can do 
is educate users to install and add it to their kickstart scripts.  Forcing 
smolt to run would be inappropriate I think.
Comment 5 Răzvan Sandu 2007-07-01 05:10:07 EDT
Hello,

(following comment #4)


...OR a more simple scenario:

Some user (experienced admin or average user) installs Fedora from CD. In 99%
situations, they use graphical installation in English language.

After restart, computer has default runlevel 5 in /etc/inittab. User runs smolt
at firstboot, registering its workstation as using runlevel 5, kernel 3194
present on CD and English language.

User logs in as root and manually modifies /etc/inittab to runlevel 3, language
to what he desires and perform kernel upgrades via yum.

Now there are 2 possible cases:
- user enables monthly smolt checking - his workstation will be registered as
running in runlevel 3, correct language and other kernel, but after a month
delay, at best;
- user does not enable monthly smolt checking - the workstation never gets
registered as running in with new parameters.

... OR another scenatio, too:

User runs Fedora from LiveCD, for hardware testing, planning a future runlevel 3
installation (I personally boot many machines from Live CD, just to send their
hardware profile to smolt server). Usually one does not use another language
than default English.

If user doesn't manually change default runlevel in /etc/inittab, workstation
gets registered with runlevel 5, English language and the 3194 kernel which is
present on LiveCD. This automatically denaturates statistics.


Possible solution:
When smolt is run from firstboot, for the first time, register all hardware data
*except* default runlevel, kernel version and language used.


Regards,
Răzvan
Comment 6 Mike McGrath 2007-07-01 11:01:07 EDT
So you're suggesting we don't store runlevel, kernel or language at all?
Comment 7 Răzvan Sandu 2007-07-02 01:51:32 EDT
Hello,


My suggestion is that we don't store runlevel, kernel or language *when smolt is
run for the first time, from firstboot*. We store just hardware data and the
other few details.


Regards,
Răzvan
Comment 8 Bug Zapper 2008-04-03 20:59:54 EDT
Based on the date this bug was created, it appears to have been reported
against rawhide during the development of a Fedora release that is no
longer maintained. In order to refocus our efforts as a project we are
flagging all of the open bugs for releases which are no longer
maintained. If this bug remains in NEEDINFO thirty (30) days from now,
we will automatically close it.

If you can reproduce this bug in a maintained Fedora version (7, 8, or
rawhide), please change this bug to the respective version and change
the status to ASSIGNED. (If you're unable to change the bug's version
or status, add a comment to the bug and someone will change it for you.)

Thanks for your help, and we apologize again that we haven't handled
these issues to this point.

The process we're following is outlined here:
http://fedoraproject.org/wiki/BugZappers/F9CleanUp

We will be following the process here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping to ensure this
doesn't happen again.
Comment 9 Răzvan Sandu 2008-04-04 04:19:56 EDT
I think this "bug" is still present and unaddresed today (Fedora 8 as of April
4th, 2008), because:

- it's hard to believe that only 2% of the users run Fedora in runlevel 3, as
you may see in the present smolt statistics;

- smolt-firstboot still reports kernel version, language and default runlevel
*at boot*, before any administrator had a chance to set them manually or perform
online updates.


Regards,
Răzvan

Comment 10 Jon Stanley 2008-04-05 11:23:21 EDT
Well, I'll let Mike comment on this (again), but smolt does have a fairly low
penetration among systems that are running in runlevel 3.  This is for the
reasons noted above - a kickstart installation will never run firstboot,
therefore the user will never be given an opportunity to enable smolt, and as of
right now in rawhide, there is no firstboot TUI anyway, so we can't even enable
it there.  Those that have enabled however, as noted, have also enabled the
monthly checkin, therefore any changes to those systems would be reflected at
the first of the month.  My personal guess is that very few server installations
of Fedroa will ever be installed in a graphical mode to enable smolt.

I'm tempted to close this NOTABUG since it's really a fundamental design
limitation of smolt, but I'll let Mike make that call.  I believe that the
latest numbers that I've seen indicate that smolt is only actually enabled on
about 10% of systems - but don't quote me on that one :)
Comment 11 Răzvan Sandu 2008-04-05 12:53:57 EDT
@Jon (comment #10)
Maybe you're right - but I don't understand why you asimilate systems running in
rulevel 3 with kickstart installations, as a must. Personally, I am running a
network of more than 1000 computers and all are installed by hand, from DVD. All
run in runlevel 3 and all have smolt enabled by default.

As a matter of fact, I've made some lobby for Ubuntu developers to adopt smolt
too, so the statistics be unified.

I also suggested that statistics provided by smolt and by the LinuxCounter
machine-update script should be integrated, through cooperation (please see bug
#433105).


Regards,
Răzvan
Comment 12 Jon Stanley 2008-04-05 22:42:22 EDT
I'm sorry, I didn't mean to equate runlevel3 with kickstart only - and I
definitely agree that smolt should be more widespread than just Fedora, just
mentioning that there are issues with any sort of opt-in automated data
collection such as this, because there are quite common ways of installation
that would result in systems being excluded.

As for the stats being bogus, anything that changes via admin intervention will
show up in the next months checkin.

And as for your 1000 systems deployed via DVD - you might wanna look into
kickstart :)  It will make your life easier :)
Comment 13 Bug Zapper 2008-05-13 22:57:21 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 14 Bug Zapper 2009-06-09 18:37:31 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 15 Mike McGrath 2009-06-09 19:42:02 EDT
Moving release, valid bug and I still have no idea how to fix it.
Comment 16 Răzvan Sandu 2009-06-10 02:20:10 EDT
Hello,


My two cents:   ;-)

The question would be if is there a way to make smolt behave *differently* when it is run by firstboot, as oposed to "normal" behaviour (when it is run by hand or by nightly cron).

If such a possibility exists, then please exclude the following data when smolt is run by firstboot (as suggested in comment #7):

- default runlevel
- kernel version
- system default language

The idea is that a guy installing Fedora in graphical mode will see and allow smolt to run by cron, collecting a minimal set of data at first run.

Immediately after installation, if he chooses to switch to default runlevel 3, to personalise the system default language or to upgrade the kernel, these changes will only be reported in subsequent runs of smolt (*after* they are crafted by hand, not with the initial default values).

This way we will get a more balanced idea of what systems really are like.

Regards,
Răzvan
Comment 17 Bug Zapper 2010-04-27 07:43:04 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 18 Bug Zapper 2010-06-28 06:24:57 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.